# -*- coding: utf-8 -*-
"""
Created on Fri Dec 18 08:47:35 2020

@author: gregory.viateau
"""
import random as rd

class Noeud:
    def __init__(self, e, g, d):
        self.e = e
        self.g = g
        self.d = d
     
    def etiquette(self):
        return self.e
     
    def gauche(self):
        return self.g
     
    def droit(self):
        return self.d


arbre_vide = None

def est_vide(arbre):
   return arbre is arbre_vide

def etiquette(arbre):
    return arbre.etiquette()

def gauche(arbre):
    return arbre.gauche()

def droit(arbre):
    return arbre.droit()


def genere_arbre(n, p=0.9, valeurs = None):
    """
    Genère un arbre binaire à n niveaux dont les étiquettes
    sont dans la liste valeurs.
    Chaque noeud a une probabilité p d'avoir un fils gauche et
    la même probabilité p d'avoir un fils droit.
    """
    if valeurs==None:
        valeurs = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]
    if n== 0:
        return arbre_vide
    else:
        e = valeurs[rd.randrange(len(valeurs))]
        if rd.random() < p:
            g = genere_arbre(n-1, p, valeurs)
        else:
            g = arbre_vide
        if rd.random() < p:
            d = genere_arbre(n-1, p, valeurs)
        else:
            d = arbre_vide
        return Noeud(e, g, d)


def genere_arbre_numerotation(n, p=0.9, numero = None):
    """
    Genère un arbre binaire à n niveaux en numérotant les noeuds.
    Cela permet d'obtenir des noeuds ayant tous une étiquette différente.
    Chaque noeud a une probabilité p d'avoir un fils gauche et
    la même probabilité p d'avoir un fils droit.
    """
    if numero==None:
        numero = [0]
    e = numero[-1]
    if rd.random() < p and n > 1:
        numero[0] += 1
        g = genere_arbre_numerotation(n-1, p, numero)
    else:
        g = arbre_vide
    if rd.random() < p and n > 1:
        numero[0] += 1            
        d = genere_arbre_numerotation(n-1, p, numero)
    else:
        d = arbre_vide
    return Noeud(e, g, d)
    
      
        
        
    


    